from ensemble.lib.twistutils import gather_results


def command(options):
    """
    Shutdown machine providers in all configured environments.
    """
    actions = []

    for environment_name in options.environments.get_names():
        environment = options.environments.get(environment_name)
        provider = environment.get_machine_provider()
        actions.append(provider.shutdown())

    return gather_results(actions)
